Registry Editor

Registry Editor is an advanced tool for viewing and changing settings in your system registry, which contains information about how your computer runs. Windows stores its configuration information in a database, known as the registry, that is organized in a tree format. Although Registry Editor enables you to inspect and modify the registry, normally you do not need to do so, and making incorrect changes can break your system. An advanced user who is prepared to both edit and restore the registry can safely use Registry Editor for such tasks as eliminating duplicate entries or deleting entries for programs that have been uninstalled or deleted.

  • For tips about using Registry Editor, see Best practices.
  • For help with specific tasks, see How to.
  • For general background information, see Concepts.


How to...

  • Change keys and values
  • Import or export registry keys
  • Load or unload registry hives
  • Maintain registry security
  • Print all or part of the registry


Change keys and values

  • Find a string, value, or key
  • Add a registry key to Favorites
  • Add a registry key
  • Add a value to a registry key entry
  • Change a value
  • Delete a registry key or value
  • Rename a registry key or value
  • Connect to a registry over the network
  • Disconnect from a network registry
  • Copy a registry key name
  • Restore the registry


Find a string, value, or key

Microsoft Windows graphic

To find a string, value, or key

  1. Open Registry Editor.
  2. On the Edit menu, click Find.
  3. In Find what, type the string, value, or key you want to find.
  4. Select the Keys, Values, Data, and Match whole string only check boxes to match the type of search you want, and then click Find Next.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • You can speed up the search by looking through only one type of information; for example, if you know that you are looking for a entry, you can clear the Keys and Data check boxes, so that you will not search through those objects.
  • To repeat the search, press F3.

Related Topics


Add a registry key to Favorites

To add a registry key to Favorites

  1. Open Registry Editor.
  2. Select the registry key you want to add to Favorites.
  3. On the Favorites menu, click Add to Favorites.
  4. In the Add to Favorites dialog box, accept the default registry key name or type a new one.

    5. The registry key is added to the Favorites list. You can then return to this list by simply selecting it from the Favorites menu.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • You can create a list of favorite/frequently visited registry keys.
  • To remove a registry key from the Favorites list, on the Favorites menu, click Remove Favorite, and you can select one or more registry keys to remove from the Favorites list.
  • Renaming a favorite does not rename the corresponding registry key.


Add a registry key

To add a registry key

  1. Open Registry Editor.
  2. In the registry tree (on the left), click the registry key under which you would like to add a new key.
  3. On the Edit menu, point to New, and then click Key.
  4. Type a name for the new key, and then press ENTER.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions, see Related Topics.


Add a value to a registry key entry

To add a value to a registry key entry

  1. Open Registry Editor.
  2. Click the key or entry where you want to add the new value.
  3. On the Edit menu, point to New, and then click the type of value you want to add: String Value, Binary Value, DWORD Value, Multi-String Value, or Expandable String Value.
  4. Type a name for the new value, then press ENTER.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions on how to restore the registry, see Related Topics.
  • When you add a value, the value name and data type are saved with a default value. For instructions on how to modify the default value, see Related Topics.


Change a value

To change a value

  1. Open Registry Editor.
  2. Select the entry you want to change.
  3. On the Edit menu, click Modify.
  4. In Value data, type the new data for the value, and then click OK.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions, see Related Topics.
  • To make changes to a registry key, you must have the appropriate permissions. For more information, see Related Topics.


Delete a registry key or value

To delete a registry key or value

  1. Open Registry Editor.
  2. Click the key or entry you want to delete.
  3. On the Edit menu, click Delete.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • You can delete keys and values from your registry. However, you cannot delete a predefined key (such as HKEY_CURRENT_USER) or change the name of a predefined key.
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions, see Related Topics.


Rename a registry key or value

To rename a registry key or value

  1. Open Registry Editor.
  2. Click the key or entry you want to rename.
  3. On the Edit menu, click Rename.
  4. Type the new name, and then press ENTER.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For information, see Related Topics.
  • You cannot rename the root keys or the default value of a key.


Connect to a registry over a network

To connect to a registry over a network

  1. Open Registry Editor.
  2. On the File menu, click Connect Network Registry.
  3. In the Select Computer dialog box, type the name of the computer to whose registry you want to connect.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • You must be logged on as an administrator or a member of the Administrators group on both your computer and on the remote computer before you can make any changes to the remote computer's registry. Network policy settings may also prevent you from completing this procedure.
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions on how to restore the registry, see Related Topics.


Disconnect from a network registry

To disconnect from a network registry

  1. Open Registry Editor.
  2. On the File menu, click Disconnect Network Registry.
  3. In the Disconnect Network Registry dialog box, click the name of the computer from whose registry you want to disconnect.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions on how to restore the registry, see Related Topics.


Copy a registry key name

To copy a registry key name

  1. Open Registry Editor.
  2. In the registry tree (on the left), click a registry key.
  3. On the Edit menu, click Copy Key Name.
  4. Paste the name of the registry key into another program or document.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If you make a mistake that results in your computer not starting properly, you can restore the registry. For instructions on how to restore the registry, see Related Topics.
  • For information on how to find a registry key, see Related Topics.


Restore the registry

To restore the registry

  1. Click Options, and then click Print to print these instructions. (If you are using the Help and Support Center, click Print above the topic area.) They will not be available after you shut down your computer in step 3.
  2. Open Registry Editor.
  3. Click Start, and then click Shut Down.
  4. In the list, click Restart, and then click OK.
  5. When you see the message Please select the operating system to start, press F8.
  6. Use the arrow keys to highlight Last Known Good Configuration, and then press ENTER.

    7. NUM LOCK must be off before the arrow keys on the numeric keypad will function.

  7. Use the arrow keys to highlight an operating system, and then press ENTER.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • Choosing Last Known Good Configuration provides a way to recover from problems such as a newly added driver that may be incorrect for your hardware. It does not solve problems caused by corrupted or missing drivers or files.
  • When you choose Last Known Good Configuration, Windows restores information in registry key HKLM\System\CurrentControlSet only. Any changes you have made in other registry keys remain.


Import or export registry keys

  • Export all or part of the registry to a text file
  • Import some or all of the registry
  • Export a registry key to a hive file
  • Import a registry key from a hive file


Export all or part of the registry to a text file

To export all or part of the registry to a text file

  1. Open Registry Editor.
  2. On the File menu, click Export.
  3. In File name, enter a name for the registry file.
  4. Under Export range, do one of the following:
    • To back up the entire registry, click All.
    • To back up only a particular branch of the registry tree, click Selected branch and enter the name of the branch you want to export.
  5. Click Save.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • You can use a text editor like Notepad to work with the registry files you create by exporting.
  • You can save registry files in the Windows format, in the format used in Windows 95, Windows 98, and Windows NT 4.0, as binary hive files, or as text files. Registry files are saved with .reg extensions, and text files are saved with .txt extensions.
  • In Windows Explorer, double-clicking a file with the .reg extension imports the file into the computer's registry.


Import some or all of the registry

To import some or all of the registry

  1. Open Registry Editor.
  2. On the File menu, click Import Registry File.
  3. Find the file you want to import, click the file to select it, then click Open.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Note

  • In Windows Explorer, double-clicking a file with the .reg extension imports the file into the computer's registry.


Export a registry key to a hive file

To export a registry key to a hive file

  1. Open Registry Editor.
  2. Select the key that you want to save as a file.
  3. On the File menu, click Export.
  4. In the Export Registry File dialog box, in Save in, click the drive, folder, or network computer and folder where you want to save the hive.
  5. In File name, enter a name for the hive.
  6. In Save as type, click Registry Hive Files.
  7. Click Save.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX If your computer is connected to a network, network policy settings might also prevent you from completing this procedure.
  • Registry Editor provides a number of commands that are designed primarily for the maintenance of your system. For example, Load Hive and Unload Hive allow a part of your system to be temporarily downloaded onto another computer for maintenance. Before a hive can be loaded or restored, it must be saved as a key, either to a floppy disk or to your hard disk.


Import a registry key from a hive file

To import a registry key from a hive file

  1. Open Registry Editor.
  2. Select the keys in which you want to restore the hive.
  3. On the File menu, click Import.
  4. In Look in, select the drive, folder, or network computer and folder in which the hive is located.
  5. In Files of type, click Registry Hive Files.
  6. Select the correct file name for the hive.
  7. Click Open.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX If your computer is connected to a network, network policy settings might also prevent you from completing this procedure.
  • A restored hive overwrites an existing registry key and becomes a permanent part of your configuration. For example, to perform maintenance on part of your system, you can use Export to save a hive to a disk. When you are ready, you can then use Import on the File menu to restore the saved key to your system.


Load or unload registry hives

  • Load a hive into the registry
  • Unload a hive from the registry


Load a hive into the registry

To load a hive into the registry

  1. Open Registry Editor.
  2. In the registry tree (on the left), click either the HKEY_USERS or HKEY_LOCAL_MACHINE keys.
  3. On the File menu, click Load Hive.
  4. In Look in, click the drive, folder, or network computer and folder that contains the hive you want to load.
  5. Click Open.
  6. In Key Name, type the name that you want to assign to the hive, and then click OK.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX If your computer is connected to a network, network policy settings might also prevent you from completing this procedure.
  • Load Hive and Unload Hive affect only the HKEY_USERS and HKEY_LOCAL_MACHINE keys and are active only when these predefined keys are selected. When you load a hive into the registry, the hive becomes a subkey of one of these keys.


Unload a hive from the registry

To unload a hive from the registry

  1. Open Registry Editor.
  2. Select a hive that you have previously loaded onto your system.
  3. On the File menu, click Unload Hive.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX If your computer is connected to a network, network policy settings might also prevent you from completing this procedure.
  • Load Hive and Unload Hive affect only the HKEY_USERS and HKEY_LOCAL_MACHINE keys and are active only when these predefined keys are selected. When you load a hive into the registry, the hive becomes a subkey of one of these keys.


Maintain registry scurity

Maintain registry security

  • Assign permissions to a registry key
  • Assign special access to a registry key
  • Add users or groups to the Permissions list
  • Remove users or groups from the Permissions list
  • Grant full control of a registry key
  • Audit activity on a registry key
  • Add users or groups to the Audit list
  • Remove a user or group from the Audit list
  • Take ownership of a registry key


Assign permissions to a registry key

To assign permissions to a registry key

  1. Open Registry Editor.
  2. Click the key to which you want to assign permissions.
  3. On the Edit menu, click Permissions.
  4. Assign an access level to the selected key as follows:
    • To grant the user permission to read the key contents, but not save any changes made to the file, under Permissions for name, for Read, select the Allow check box.
    • To grant the user permission to open, edit, and take ownership of the selected key, under Permissions for name, for Full Control, select the Allow check box.
    • To grant the user special permission in the selected key, click Advanced.
  5. If you are assigning permissions to a subkey and you want the inheritable permissions assigned to the parent key to apply to the subkey also, click Advanced and select the Inherit from parents the permission entries that apply to child objects. Include these with entries explicitly defined here check box.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If you own a registry key, you can specify the users and groups that can open that key. To determine who can open your registry keys, you need to assign permissions to them. You can add or remove users or groups from those authorized to access your registry keys at any time.
  • The Special Permissions check boxes indicate whether custom permissions have been set for this key, but you cannot set special permissions by clicking these check boxes. Click Advanced to set special permissions.


Assign special access to a registry key

To assign special access to a registry key

  1. Open Registry Editor.
  2. Click the key to which you want to assign special access.
  3. On the Edit menu, click Permissions.
  4. Click Advanced, and then double-click the user or group to whom you want to assign special access.
  5. Under Permissions, select the Allow or Deny check box for each permission you want to allow or deny.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • Assigning special access is useful for situations in which you need to assign permissions that are not defined by either Read or Full Control.
  • If you are assigning permissions to a subkey and you want the inheritable permissions assigned to the parent key to apply to the subkey also, select the Inherit from parents the permission entries that apply to child objects. Include these with entries explicitly defined here check box.
  • If you are assigning permissions to a parent key and want any existing permissions of its subkeys replaced with the parent key's inheritable permissions, select the Replace permission entries on all child objects with entries shown here that apply to child objects check box.


Add users or groups to the Permissions list

To add users or groups to the Permissions list

  1. Open Registry Editor.
  2. Click the key whose Permissions list you want to change.
  3. On the Edit menu, click Permissions, and then click Add.
  4. In the Select Users, Computers, or Groups dialog box, click Locations, and then click the computer or domain of the users and groups you want to view.
  5. Type the name or names of the users or groups you would like to add, separating each name with a semicolon. Click Examples to see some examples of the syntax you can use to enter names. Click Check Names to validate names with the directory. When you are finished entering names, click OK.
  6. In the Permissions dialog box, under Permissions for name, assign a type of access to the selected user or group as follows:
    • To grant the user permission to read the key contents but not to save any changes made to it, select the Allow check box for Read.
    • To grant the user permission to open, edit, and take ownership of the selected key, select the Allow check box for Full Control.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If the check boxes under Permissions are shaded, the key has inherited permissions from the parent object key.
  • To allow permissions assigned to a parent key to apply to its subkeys also, click Advanced, and select the Inherit from parent the permission entries that apply to child objects. Include these with entries explicitly defined here check box.
  • In the Select Users, Computers, or Groups dialog box, if you type the name, rather than selecting it, click Check Names before clicking OK.


Remove a user or group from the Permissions list

To remove a user or group from the Permissions list

  1. Open Registry Editor.
  2. Click the key whose Permissions list you want to change.
  3. On the Edit menu, click Permissions.
  4. Under Group or user names: , Click the name of the user or group that you want to remove from the Permissions list.
  5. Click Remove.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX


Grant full control of a registry key

To grant full control of a registry key

  1. Open Registry Editor.
  2. Click the key to which you want to grant full control.
  3. On the Edit menu, click Permissions.
  4. Under Group or user names, click the user to whom you want to grant full control of your registry key.
  5. Under Permissions for name, where name represents the name of the user to whom you are granting full control of the key, select the Allow check box for Full Control.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • You can permit another user to take ownership of a registry key only if you are the current owner of the key.
  • To permit a user to to take ownership of a registry key, you must first assign the user Full Control of the key.


Audit activity on a registry key

To audit activity on a registry key

  1. Open Registry Editor.
  2. Click the key you want to audit.
  3. On the Edit menu, click Permissions.
  4. Click Advanced, and then click the Auditing tab.
  5. Double-click the name of a group or user.
  6. Under Access, select or clear the Successful and Failed check boxes for the activities that you want to audit or to stop auditing:
    Select | To audit
    Query Value | Any attempts to read a entry from a registry key
    Set Value | Any attempts to set entries in a registry key
    Create Subkey | Any attempts to create subkeys on a selected registry key
    Enumerate Subkeys | Any attempts to identify the subkeys of a registry key
    Notify | Any notification events from a key in the registry
    Create Link | Any attempts to create a symbolic link in a particular key
    Delete | Any attempts to delete a registry object
    Write DAC | Any attempts to write a discretionary access control list on the key
    Write Owner | Any attempts to change the owner of the selected key
    Read Control | Any attempts to open the discretionary access control list on a key

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • If your computer is connected to a network, network policy settings might prevent you from completing this procedure.
  • You must first add users and groups before specifying the events to audit.
  • Auditing activity can slow the computer down significantly. Consider auditing only failures, and not successes.


Add users or groups to the Audit list

To add users or groups to the Audit list

  1. Open Registry Editor.
  2. Click the key you want to audit.
  3. On the Edit menu, click Permissions.
  4. Click Advanced, click the Auditing tab, and then click Add.
  5. Click Object Types, select the type or types of users or groups you want to find, and then click OK.
  6. Click Locations, select the computer or domain of the users or groups you want to view, and then click OK.
  7. Type the name of the user or group you want to add and then click OK to open the Auditing Entry dialog box, or click Advanced to search for a user, computer, or group based on parameters you set.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX If your computer is connected to a network, network policy settings might also prevent you from completing this procedure.
  • You must first add a user or group before specifying which events to audit.


Remove a user or group from the audit list

To remove a user or group from the audit list

  1. Open Registry Editor.
  2. Click the key whose Audit list you want to change.
  3. On the Edit menu, click Permissions.
  4. Click Advanced, and then click the Auditing tab.
  5. Click the user or group that you want to remove, and then click Remove.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX If your computer is connected to a network, network policy settings might also prevent you from completing this procedure.


Take ownership of a registry key

To take ownership of a registry key

  1. Open Registry Editor.
  2. Click the key you want to take ownership of.
  3. On the Edit menu, click Permissions.
  4. Click Advanced, and then click the Owner tab.
  5. Under Change owner to, click the new owner, and then click OK.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • You can take ownership of a registry key if you are logged on as an administrator or if you have been specifically assigned the permission to take ownership of the registry key by the current owner.


Print all or part of the registry

To print all or part of the registry

  1. Open Registry Editor.
  2. Click the computer or top-level key of the registry area you want to print.
  3. On the File menu, click Print.
  4. You can print the entire registry by clicking All or only part of the registry by clicking Selected Branch and typing a particular branch in the text box, and then click OK.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • XOX
  • The average registry can take hundreds of pages to print. Consider printing only those branches you need.


Concepts

  • Registry Editor overview


Registry Editor overview

Registry Editor is an advanced tool for viewing and changing settings in your system registry, which contains information about how your computer runs. Windows® stores its configuration information in a database (the registry) that is organized in a tree format. Although Registry Editor enables you to inspect and modify the registry, normally you do not need to do so, and making incorrect changes can break your system. An advanced user who is prepared to both edit and restore the registry can safely use Registry Editor for such tasks as eliminating duplicate entries or deleting entries for programs that have been uninstalled or deleted.

Folders represent keys in the registry and are shown in the navigation area on the left side of the Registry Editor window. In the topic area on the right, the entries in a key are displayed. When you double-click a entry, it opens an editing dialog box.

You should not edit your registry unless it is absolutely necessary. If there is an error in your registry, your computer may not function properly. If this happens, you can restore the registry to the same version you were using when you last successfully started your computer. For instructions, see Related Topics.

Registry Editor Keys

The navigation area of the Registry Editor displays folders, each of which represents a predefined key on the local computer. When accessing the registry of a remote computer, only two predefined keys, HKEY_USERS and HKEY_LOCAL_MACHINE, appear.

Folder/predefined key | Description
HKEY_CURRENT_USER | Contains the root of the configuration information for the user who is currently logged on. The user's folders, screen colors, and Control Panel settings are stored here. This information is referred to as a user's profile.
HKEY_USERS | Contains the root of all user profiles on the computer. HKEY_CURRENT_USER is a subkey of HKEY_USERS.
HKEY_LOCAL_MACHINE | Contains configuration information particular to the computer (for any user).
HKEY_CLASSES_ROOT | Is a subkey of HKEY_LOCAL_MACHINE\Software. The information stored here ensures that the correct program opens when you open a file by using Windows Explorer.
HKEY_CURRENT_CONFIG | Contains information about the hardware profile used by the local computer at system startup.

The following table lists the data types currently defined and used by the system.

Data type | Description
REG_BINARY | Raw binary data. Most hardware component information is stored as binary data and is displayed in Registry Editor in hexadecimal format.
REG_DWORD | Data represented by a number that is 4 bytes long. Many parameters for device drivers and services are this type and are displayed in Registry Editor in binary, hexadecimal, or decimal format.
REG_EXPAND_SZ | A variable-length data string. This data type includes variables that are resolved when a program or service uses the data.
REG_MULTI_SZ | A multiple string. Values that contain lists or multiple values in a form that people can read are usually this type. Entries are separated by spaces, commas, or other marks.
REG_SZ | A fixed-length text string.
REG_FULL_RESOURCE_DESCRIPTOR | A series of nested arrays designed to store a resource list for a hardware component or driver.

Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on your computer.

Notes

  • XOX
  • Some previous versions of Windows had two versions of Registry Editor: regedit.exe and regedt32.exe. The version of Registry Editor that is included with the Microsoft® Windows® Server 2003 family replaces both versions from previous operating systems.
  • To safely use Registry Editor for such tasks as eliminating duplicate entries or deleting entries for programs that have been uninstalled or deleted, you should be prepared to both edit and restore the registry.